/*!
 * sequence.h
 *
 * Copyright (c) 2016-2018, NADAL Jean-Baptiste. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA
 * 
 * @Author:  NADAL Jean-Baptiste
 * @Date: 11/04/2018
 *
 */

#ifndef _SEQUENCE_H
#define _SEQUENCE_H

/*------------------------------- INCLUDES ----------------------------------*/

#include <string>
#include <vector>

#include "sequences/action.h"

#include "sequences/timer.h"

/*---------------------------------- Deps -----------------------------------*/

struct json_object;
class DevicesManager;

/*--------------------------------- CLASS ----------------------------------*/

class Sequence
{
public:
  Sequence(void);
  ~Sequence(void);

  int from_json(struct json_object *a_node);
  struct json_object *to_json(void);

  uint16_t get_id(void) const;
  const std::string &get_name(void) const;
  const Timer &get_timer(void) const;
  const Action &get_action(void) const;

  bool is_active(void);
  bool is_in_progress(void);

  uint16_t get_duration(void) const;

  void start(DevicesManager *a_device_manager);
  void stop(void);
  bool switch_to_next_action(DevicesManager *a_device_manager);

private:
  bool m_is_in_progress;
  uint16_t m_id;
  std::string m_name;
  Timer m_timer;
  std::vector<Action> m_actions;
  uint16_t m_current_action;
  uint16_t m_current_duration;
};

#endif /* _SEQUENCE_H */
